import SVG from "svg.js"
import SvgDrag from "svg.draggable.js"
import algebra from "algebra.js"
import svgIntersections from "svg-intersections"
var intersect = svgIntersections.intersect;
var shape = svgIntersections.shape;



SVG.on(window, 'resize', function() { svg.spof() });
var svg = SVG('drawing');
var links = svg.group();
var markers = svg.group();
var nodes = svg.group();

var g1 = nodes.group().translate(300, 100).draggable();
g1.rect(100, 60).fill("#C2185B");
var g2 = nodes.group().translate(100, 100).draggable();
g2.rect(100, 60).fill("#E91E63");
var g3 = nodes.group().translate(200, 300).draggable();
g3.circle(100).fill("#FF5252");

var txt = svg.text("Test").font({
    size: 20
}).draggable();

var line1 = svg.line(g1.cx(), g1.cy(), txt.cx(), txt.cy()).stroke({ width: 1 });
var line2 = svg.line(txt.cx(), txt.cy(), g2.cx(), g2.cy()).stroke({ width: 1 });

g1.on("dragmove", function (e) {
    lineStartCorrdinates(line1, g1, txt);
    lineEndCoordinates(line2, g2, txt);
});

g2.on("dragmove", function (e) {
    lineStartCorrdinates(line1, g1, txt);
    lineEndCoordinates(line2, g2, txt);
});

txt.on("dragmove", function (e) {
    lineStartCorrdinates(line1, g1, txt);
    lineEndCoordinates(line2, g2, txt);
});

function lineStartCorrdinates(startLine, startElem, label) {
    startLine.plot(
        startElem.cx(),
        startElem.cy(),
        label.cx(),
        label.cy()
    );

    var intersections = intersect(
        shape("line", {x1: startLine.attr("x1"), y1:startLine.attr("y1"), x2:startLine.attr("x2"), y2:startLine.attr("y2")}),
        shape("rect", {x:startElem.x(), y:startElem.y(), width:100, height:60})
    );

    if(intersections.points.length > 0) {
        startLine.plot(
            intersections.points[0].x,
            intersections.points[0].y,
            label.cx(),
            label.cy()
        );
    }
}

function lineEndCoordinates(endLine, endElem, label) {
    endLine.plot(
        endElem.cx(),
        endElem.cy(),
        label.cx(),
        label.cy()
    );

    var intersections = intersect(
        shape("line", {x1: endLine.attr("x1"), y1:endLine.attr("y1"), x2:endLine.attr("x2"), y2:endLine.attr("y2")}),
        shape("rect", {x:endElem.x(), y:endElem.y(), width:100, height:60})
    );

    if(intersections.points.length > 0) {
        endLine.plot(
            intersections.points[0].x,
            intersections.points[0].y,
            label.cx(),
            label.cy()
        );
    }
}